<?php

/**
* PHP versions 4 and 5
*
* LICENSE: This source file is subject to version 3.0 of the PHP license
* that is available through the world-wide-web at the following URI:
* http://www.php.net/license. If you did not receive a copy of
* the PHP License and are unable to obtain it through the web, please
* send a note to license@php.net so we can mail you a copy immediately.
*
* @package    QuickTicket
* @author     Philippe Vandenberghe <info@qt-cute.org>
* @copyright  2008-2012 The PHP Group
* @version    2.3 build:20091102
*/

session_start();
require_once('bin/qti_init.php');
include(Translate('qti_adm.php'));
include(Translate('qtim_export.php'));
if ( $oVIP->role!='A' ) die($L['E_admin']);

include('bin/qti_fn_sql.php');

function DbToSql($str,$strR='NULL',$strE='"')
{
  if ( is_null($str) ) return $strR;
  if ( $str==='' || $str==='""' ) return $strR;
  return $strE.addslashes($str).$strE;
}

// INITIALISE

$arrYears = array(
  '*'=>'[ '.$L['All'].' ]',
  strval(date('Y'))=>strval(date('Y')),
  strval(date('Y')-1)=>strval(date('Y')-1),
  strval(date('Y')-2)=>strval(date('Y')-2),
  strval(date('Y')-3)=>strval(date('Y')-3),
  'old'=>'&lt; '.strval(date('Y')-4)
  );

if ( !isset($_SESSION['m_export']) )
{
  $_SESSION['m_export'] = array(
  'title'     => 'export_'.date('Ymd'),
  'format'    => 'XML',
  'delimit'   => ';',
  'enclose'   => '"',
  'null'      => 'NULL',
  'dropbbc'   => 'Y',
  'firstline' => 'Y');
}

$oVIP->selfurl = 'qtim_export_adm.php';
$oVIP->selfname = $L['export']['Admin'];
$oVIP->exiturl = $oVIP->selfurl;
$oVIP->exitname = $oVIP->selfname;
$strPageversion = $L['Version'].' 2.3<br/>';

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  // read and check mandatory

  $_SESSION['m_export']['title'] = trim($_POST['title']);
  $_SESSION['m_export']['format'] = trim($_POST['format']);
  $_SESSION['m_export']['delimit'] = trim($_POST['delimiter']);
  $_SESSION['m_export']['enclose'] = $_POST['enclose']; if ( get_magic_quotes_gpc() ) $_SESSION['m_export']['enclose'] = stripslashes($_POST['enclose']);
  $_SESSION['m_export']['null'] = trim($_POST['null']);
  if ( isset($_POST['dropbbc']) ) { $_SESSION['m_export']['dropbbc']='Y'; } else { $_SESSION['m_export']['dropbbc']='N'; }
  if ( isset($_POST['firstline']) ) { $_SESSION['m_export']['firstline']='Y'; } else { $_SESSION['m_export']['firstline']='N'; }
  if ( empty($_SESSION['m_export']['delimit']) ) $error=$L['export']['Delimiter'].' '.$L['E_invalid'];

  // check values

  if ( empty($error) )
  {
    if ( strlen($_SESSION['m_export']['delimit'])==1 )
    {
    if ( ereg('[0-9A-Za-z]',$_SESSION['m_export']['delimit']) ) $error=$L['export']['Delimiter'].' '.$L['E_invalid'];
    }
    if ( strlen($_SESSION['m_export']['enclose'])==1 )
    {
    if ( ereg('[0-9A-Za-z]',$_SESSION['m_export']['enclose']) ) $error=$L['export']['Encloser'].' '.$L['E_invalid'];
    }
    if ( $_SESSION['m_export']['format']=='SQL' ) $_SESSION['m_export']['delimit'] = ',';
  }

  // check conflict

  $strEnclose = '"'; if ( $_SESSION['m_export']['enclose']=='"' || $_SESSION['m_export']['enclose']=="'" ) $strEnclose = '';
  $strDelimit = ';'; if ( $_SESSION['m_export']['delimit']==';' ) $strDelimit = ',';

  // COUNT

  if ( empty($error) )
  {
    $strWhere = '';
    if ( $_POST['section']!='*' ) { $strWhere .= ' p.forum='.$_POST['section']; } else { $strWhere .= 'p.forum>=0'; }
    if ( $_POST['year']!='*' ) $strWhere .= ' AND '.SqlDateCondition($_POST['year'],'p.issuedate');
    $oDB->Query( 'SELECT count(*) as countid FROM '.TABPOST.' p INNER JOIN '.TABTOPIC.' t ON p.topic=t.id WHERE '.$strWhere );
    $row=$oDB->Getrow();
    if ( $row['countid']==0 ) $error='No data found';
  }

  // EXPORT

  $strE = $_SESSION['m_export']['enclose'];
  $strD = $_SESSION['m_export']['delimit'];
  $strN = $_SESSION['m_export']['null'];

  // ========
  if ( empty($error) ) {
  switch($_SESSION['m_export']['format']) {
  // ========

  case 'CSV':

  $oDB->Query( 'SELECT p.*,t.numid,t.x,t.y,t.z,t.type as topictype,t.tags FROM '.TABPOST.' p INNER JOIN '.TABTOPIC.' t ON p.topic=t.id WHERE '.$strWhere.' ORDER BY p.topic,p.id' );

  // header
  
  if (!headers_sent())
  {
    header('Content-Type: text/csv; charset='.QTI_HTML_CHAR);
    header('Content-Disposition: attachment; filename="'.$_SESSION['m_export']['title'].'.csv"');
  }
  
  // first line
  
  if ( $_SESSION['m_export']['firstline']=='Y' ) echo $strE.'id'.$strE.$strD.$strE.'forum'.$strE.$strD.$strE.'topic'.$strE.$strD.$strE.'type'.$strE.$strD.$strE.'username'.$strE.$strD.$strE.'title'.$strE.$strD.$strE."issuedate".$strE.$strD.$strE.'numid'.$strE.$strD.$strE.'textmsg'.$strE.$strD.$strE.'x'.$strE.$strD.$strE.'y'.$strE.$strD.$strE.'z'.$strE.$strD.$strE.'topictype'.$strE.$strD.$strE.'tags'.$strE."\r\n";

  // export rows
  
  While( $row=$oDB->Getrow() )
  {    
    // title pre-process
    if ( !is_string($row['title']) ) $row['title']='';
    $row['title'] = QTconv($row['title'],'-4');
    $row['title'] = str_replace("\r\n",' ',$row['title']);
    $row['title'] = str_replace($strE,$strEnclose,$row['title']);
    $row['title'] = str_replace($strD,$strDelimit,$row['title']);
    // text pre-process    
    if ( $oDB->type=='db2' || $oDB->type=='db2' ) {
    if ( $row['type']=='D' ) {
      $row['textmsg'] = $row['textmsg2'];
    }}
    if ( !is_string($row['textmsg']) ) $row['textmsg']='';
    if ( $_SESSION['m_export']['dropbbc']=='Y' && strlen($row['textmsg'])>5 ) $row['textmsg'] = QTunbbc($row['textmsg'],false);
    $row['textmsg'] = QTconv($row['textmsg'],'-4');
    $row['textmsg'] = str_replace("\r\n",'\n',$row['textmsg']);
    $row['textmsg'] = str_replace($strE,$strEnclose,$row['textmsg']);
    $row['textmsg'] = str_replace($strD,$strDelimit,$row['textmsg']);
    // coord pre-process
    if ( empty($row['x']) || substr($row['x'],0,6)=='0.0000') $row['x']=$strN;
    if ( empty($row['y']) || substr($row['y'],0,6)=='0.0000') $row['y']=$strN;
    if ( empty($row['z']) || substr($row['z'],0,4)=='0.00') $row['z']=$strN;

    // combine
    $str  = $row['id'].$strD;
    $str .= $row['forum'].$strD;
    $str .= $row['topic'].$strD;
    $str .= DbToSql($row['type'],'R',$strE).$strD;
    $str .= DbToSql($row['username'],'Visitor',$strE).$strD;
    $str .= DbToSql($row['title'],$strN,$strE).$strD;
    $str .= DbToSql($row['issuedate'],date('Ymd His'),$strE).$strD;
    $str .= DbToSql($row['numid'],'0','').$strD;
    $str .= DbToSql($row['textmsg'],$strN,$strE).$strD;
    $str .= $row['x'].$strD;
    $str .= $row['y'].$strD;
    $str .= $row['z'].$strD;
    if ( $row['type']=='P' ) 
    {
    $str .= DbToSql(strtoupper(substr($row['topictype'],0,1)),'T',$strE).$strD; // topictype (new since version 2.3)
    $str .= DbToSql($row['tags'],$strN,$strE);
    }
    else
    {
    $str .= $strN.$strD;
    $str .= $strN;
    }

    // output
    echo $str."\r\n";
  }

  break;

  // ========

  case 'SQL':

  $oDB->Query( 'SELECT p.* FROM '.TABPOST.' p WHERE '.$strWhere.' ORDER BY p.topic,p.id' );

  // header
  
  if (!headers_sent())
  {
    header('Content-Type: text/plain; charset='.QTI_HTML_CHAR);
    header('Content-Disposition: attachment; filename="'.$_SESSION['m_export']['title'].'.sql"');
  }

  // first line
  
  if ( $_SESSION['m_export']['firstline']=='Y' ) echo '# Table '.TABPOST." (userid must be reset to 0, username must be reset to Visitor).\r\n";

  // export post rows
  
  While( $row=$oDB->Getrow() )
  {
    // pre-process
    if ( !is_string($row['title']) ) $row['title']='';
    $row['title'] = str_replace("\r\n",' ',$row['title']);
    $row['textmsg'] = str_replace("\r\n",'\n',$row['textmsg']);

    // combine
    $strF = implode(',',array_keys($row));
    $str  = $row['id'].',';
    $str .= $row['forum'].',';
    $str .= $row['topic'].',';
    $str .= DbToSql($row['icon'],$strE,'00').',';
    $str .= DbToSql($row['title'],$strE,$strN).',';
    $str .= DbToSql($row['type'],$strE,'R').',';
    $str .= DbToSql($row['userid'],'','0').',';
    $str .= DbToSql($row['username'],$strE,$strN).',';
    $str .= DbToSql($row['issuedate'],$strE,date('Ymd His')).',';
    $str .= DbToSql($row['modifdate'],$strE,'0').',';
    $str .= DbToSql($row['modifuser'],'','0').',';
    $str .= DbToSql($row['modifname'],$strE,$strN).',';
    $str .= DbToSql($row['attach'],$strE,$strN).',';
    $str .= DbToSql($row['textmsg'],$strE,$strN);

    // output
    echo 'INSERT INTO '.TABPOST.' ('.$strF.') VALUES ('.$str.')'."\r\n";
  }
  
  // first line
  
  if ( $_SESSION['m_export']['firstline']=='Y' ) echo '# Table'.TABTOPIC."(firstpost/lastpost must be recomputed, status must be reset to A)\r\n";

  // export topic rows

  $oDB->Query( 'SELECT t.* FROM '.TABPOST.' p INNER JOIN '.TABTOPIC.' t ON p.topic=t.id WHERE '.$strWhere.' ORDER BY p.topic,p.id' );

  While( $row=$oDB->Getrow() )
  {
    $strF = implode(',',array_keys($row));
    $str  = $row['id'].',';
    $str .= $row['numid'].',';
    $str .= $row['forum'].',';
    $str .= DbToSql($row['type'],$strE,'T').',';
    $str .= DbToSql($row['status'],$strE,'A').',';
    $str .= DbToSql($row['wisheddate'],$strE,'0').',';
    $str .= DbToSql($row['tags'],$strE,$strN).',';
    $str .= DbToSql($row['firstpostid'],'','0').',';
    $str .= DbToSql($row['lastpostid'],'','0').',';
    $str .= DbToSql($row['firstpostuser'],'','0').',';
    $str .= DbToSql($row['lastpostuser'],'','0').',';
    $str .= DbToSql($row['firstpostname'],$strE,'Visitor').',';
    $str .= DbToSql($row['lastpostname'],$strE,'Visitor').',';
    $str .= DbToSql($row['firstpostdate'],$strE,'0').',';
    $str .= DbToSql($row['lastpostdate'],$strE,'0').',';
    $str .= $row['x'].',';
    $str .= $row['y'].',';
    $str .= $row['z'].',';
    $str .= DbToSql($row['actorid'],'','0').',';
    $str .= DbToSql($row['actorname'],$strE,'Admin').',';
    $str .= DbToSql($row['notifiedid'],'','0').',';
    $str .= DbToSql($row['notifiedname'],$strE,$strN).',';
    $str .= DbToSql($row['replies'],'','0').',';
    $str .= DbToSql($row['views'],'','0').',';
    $str .= DbToSql($row['modifdate'],$strE,'0');

    // output
    echo 'INSERT INTO '.TABTOPIC.' ('.$strF.') VALUES ('.$str.')'."\r\n";
  }

  break;

  // ========

  case 'XML':

  $oDB2 = new cDB($qti_dbsystem,$qti_host,$qti_database,$qti_user,$qti_pwd,$qti_port,$qti_dsn);

  // header
  
  if (!headers_sent())
  {
    header('Content-Type: text/csv; charset='.QTI_HTML_CHAR);
    header('Content-Disposition: attachment; filename="'.$_SESSION['m_export']['title'].'.xml"');
  }

  echo '<?xml version="1.0"?>',N;
  echo '<quickticket version="2.3">',N;

  // export topic

  $strWhere = str_replace('p.','t.',$strWhere);
  $strWhere = str_replace('issuedate','firstpostdate',$strWhere);
  $oDB->Query( 'SELECT t.* FROM '.TABTOPIC.' t WHERE '.$strWhere.' ORDER BY t.id' );

  while($row=$oDB->Getrow()) 
  {
    $oTopic = new cTopic($row);

    echo '<topic id="',$oTopic->id,'" type="',$oTopic->type,'" section="',$oTopic->section,'">',N;
    echo '<numid>',$oTopic->numid,'</numid>',N;
    echo '<status>',$oTopic->status,'</status>',N;
    if ( !empty($oTopic->statusdate) )    echo '<statusdate>',$oTopic->statusdate,'</statusdate>',N;
    if ( !empty($oTopic->eventdate) )     echo '<eventdate>',$oTopic->eventdate,'</eventdate>',N;
    if ( !empty($oTopic->wisheddate) )    echo '<wisheddate>',$oTopic->wisheddate,'</wisheddate>',N;
    if ( !empty($oTopic->firstpostid) )   echo '<firstpostid>',$oTopic->firstpostid,'</firstpostid>',N;
    if ( !empty($oTopic->lastpostid) )    echo '<lastpostid>',$oTopic->lastpostid,'</lastpostid>',N;
    if ( !empty($oTopic->firstpostuser) ) echo '<firstpostuser>',$oTopic->firstpostuser,'</firstpostuser>',N;
    if ( !empty($oTopic->lastpostuser) )  echo '<lastpostuser>',$oTopic->lastpostuser,'</lastpostuser>',N;
    if ( !empty($oTopic->firstpostname) ) echo '<firstpostname>',$oTopic->firstpostname,'</firstpostname>',N;
    if ( !empty($oTopic->lastpostname) )  echo '<lastpostname>',$oTopic->lastpostname,'</lastpostname>',N;
    if ( !empty($oTopic->firstpostdate) ) echo '<firstpostdate>',$oTopic->firstpostdate,'</firstpostdate>',N;
    if ( !empty($oTopic->lastpostdate) )  echo '<lastpostdate>',$oTopic->lastpostdate,'</lastpostdate>',N;
    if ( !empty($oTopic->x) )             echo '<x>',$oTopic->x,'</x>',N;
    if ( !empty($oTopic->y) )             echo '<y>',$oTopic->y,'</y>',N;
    if ( !empty($oTopic->z) )             echo '<z>',$oTopic->z,'</z>',N;
    if ( !empty($oTopic->tags) )          echo '<tags>',$oTopic->tags,'</tags>',N;

    echo '<posts>',N;

    $oDB2->Query( 'SELECT * FROM '.TABPOST.' WHERE topic='.$oTopic->id.' ORDER BY id' );
    while($row2=$oDB2->Getrow()) 
    {
      $oPost = new cPost($row2);
      echo '<post id="',$oPost->id,'" type="',$oPost->type,'">',N;
      echo '<icon>',$oPost->icon,'</icon>',N;
      echo '<title>',$oPost->title,'</title>',N;
      echo '<userid>',$oPost->userid,'</userid>',N;
      echo '<username>',$oPost->username,'</username>',N;
      echo '<issuedate>',$oPost->issuedate,'</issuedate>',N;
      if ( !empty($oPost->modifdate) ) echo '<modifdate>',$oPost->modifdate,'</modifdate>',N;
      if ( !empty($oPost->modifuser) ) echo '<modifuser>',$oPost->modifuser,'</modifuser>',N;
      if ( !empty($oPost->modifname) ) echo '<modifname>',$oPost->modifname,'</modifname>',N;
      echo '<textmsg>',$oPost->text,'</textmsg>',N;          
      echo '</post>',N;          
    }

    echo '</posts>',N;
    echo '</topic>',N;
  }

  // end export

  echo '</quickticket>';

  break;

  // ========
  }
  exit;
  }
  // ========

}

// --------
// HTML START
// --------

$bJava=false;

include('qti_adm_p_header.php');
include('qti_adm_p_title.php');

// FORM

echo '
<script type="text/javascript">
<!--
function ValidateForm(theForm)
{
  if (theForm.title.value.length==0) { alert(qtHtmldecode("',$L['E_mandatory'],': File")); return false; }
  return null;
}
function ShowParam(theFormat)
{
  if (theFormat=="XML")
  {
  document.getElementById("tr_delimiter").style.display="none";
  document.getElementById("tr_enclose").style.display="none";
  document.getElementById("tr_null").style.display="none";
  document.getElementById("tr_firstline").style.display="none";
  }
  else
  {
  document.getElementById("tr_delimiter").style.display="table-row";
  document.getElementById("tr_enclose").style.display="table-row";
  document.getElementById("tr_null").style.display="table-row";
  document.getElementById("tr_firstline").style.display="table-row";
  }
  return null;
}
-->
</script>
';

echo '<form method="post" action="',$oVIP->selfurl,'" onsubmit="return ValidateForm(this);">
<table class="data_o" cellspacing="0">
<tr class="data_o">
<td class="th_o th_o_all" colspan="3">',$L['Adm_settings'],'</td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first" style="width:200px"><label for="format">',$L['Format'],'</label></td>
<td class="td_o"><select id="format" name="format" onchange="return ShowParam(this.value);">
<option value="XML"',($_SESSION['m_export']['format']=='XML' ? QSEL : ''),'>XML</option>
<option value="CSV"',($_SESSION['m_export']['format']=='CSV' ? QSEL : ''),'>CSV</option>
<option value="SQL"',($_SESSION['m_export']['format']=='SQL' ? QSEL : ''),'>SQL</option>
</select></td>
<td class="td_o">&nbsp;</td>
</tr>
';
echo '<tr id="tr_delimiter" class="data_o" ',($_SESSION['m_export']['format']=='XML' ? 'style="display:none"' : ''),'>
<td class="th_o th_o_first"><label for="delimiter">',$L['export']['Delimiter'],'</label></td>
<td class="td_o"><input type="text" id="delimiter" name="delimiter" size="1" maxlength="2" value="',$_SESSION['m_export']['delimit'],'"/></td>
<td class="td_o">&nbsp;</td>
</tr>
';
echo '<tr id="tr_enclose" class="data_o" ',($_SESSION['m_export']['format']=='XML' ? 'style="display:none"' : ''),'>
<td class="th_o th_o_first"><label for="enclose">',$L['export']['Encloser'],'</label></td>
<td class="td_o"><input type="text" id="enclose" name="enclose" size="1" maxlength="2" value="',htmlspecialchars($_SESSION['m_export']['enclose']),'"/></td>
<td class="td_o"><span class="help">',$L['export']['H_Encloser'],'</span></td>
</tr>
';
echo '<tr id="tr_null" class="data_o" ',($_SESSION['m_export']['format']=='XML' ? 'style="display:none"' : ''),'>
<td class="th_o th_o_first"><label for="null">',$L['export']['Replace_null'],'</label></td>
<td class="td_o"><input type="text" id="null" name="null" size="5" maxlength="24" value="',$_SESSION['m_export']['null'],'"/></td>
<td class="td_o"><span class="help">&nbsp;</span></td>
</tr>
';
echo '<tr id="tr_firstline" class="data_o" ',($_SESSION['m_export']['format']=='XML' ? 'style="display:none"' : ''),'>
<td class="th_o th_o_first">',$L['export']['First_line'],'</td>
<td class="td_o" colspan="2"><input type="checkbox" id="firstline" name="firstline"',($_SESSION['m_export']['firstline']=='Y' ? QCHE : ''),'/> <label for="firstline">',$L['export']['H_First_line'],'</label></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_all" colspan="3">',$L['Content'],'</td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first"><label for="section">',$L['Section'],'</label></td>
<td class="td_o" colspan="2">
<select id="section" name="section" size="1">
<option value="*">[ ',$L['All'],' ]</option>',QTasTag(QTarrget(GetSections('A'))),'</select>
</td>
</tr>
';
echo '<tr class="data_o">';
echo '<td class="th_o th_o_first">',$L['Messages'],'</td>';
echo '<td class="td_o"><select name="year" size="1">';
foreach($arrYears as $intKey=>$strValue)
{
echo '<option value="',$intKey,'">',$strValue,'</option>';
}
echo '</select></td>
<td class="td_o"><span class="help">&nbsp;</span></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first">',$L['export']['Drop_bbc'],'</td>
<td class="td_o" colspan="2"><input type="checkbox" id="dropbbc" name="dropbbc"',($_SESSION['m_export']['dropbbc']=='Y' ? QCHE : ''),'/> <label for="dropbbc">',$L['export']['H_Drop_bbc'],'</label></td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_all" colspan="3">',$L['Destination'],'</td>
</tr>
';
echo '<tr class="data_o">
<td class="th_o th_o_first"><label for="title">',$L['export']['Filename'],'</label></td>
<td class="td_o" colspan="2"><input type="text" id="title" name="title" size="32" maxlength="32" value="',$_SESSION['m_export']['title'],'"/></td>
</tr>';
echo '<tr class="data_o">
<td class="th_o th_o_all" colspan="3" style="padding:6px; text-align:center"><input type="submit" name="ok" value="',$L['Ok'],'"/></td>
</tr>
';
echo '</table>';
echo '</form>';

// HTML END

include('qti_adm_p_footer.php');

?>